import { system, world, EntityHurtAfterEvent } from "@minecraft/server";

import { ActionFormData } from "@minecraft/server-ui";

world.afterEvents.entityHurt.subscribe((event) => {
    const player = event.damageSource.damagingEntity;
    const hurtEntity = event.hurtEntity;
    const damage = event.damage;
    let coords = [
        { x: 0, y: 0.9, z: 0 },
        { x: 0.1, y: 0.7, z: 0.1 },
        { x: 0.2, y: 0.5, z: 0.2 },
        { x: 0.3, y: 0.3, z: 0.3 },
        { x: -0.1, y: 0.8, z: -0.1 },
        { x: -0.2, y: 0.6, z: -0.2 },
        { x: -0.3, y: 0.4, z: -0.3 }
    ];
    let randomCoords = coords[Math.floor(Math.random() * coords.length)];

    if (hurtEntity?.typeId === "target_dummy:target_dummy_entity" && !Number.isInteger(damage)) {

        let damageValue = damage.toFixed(1);
        hurtEntity.triggerEvent("on_hurt");

        hurtEntity.runCommand(`summon target_dummy:damage_value "${damageValue}" ~${randomCoords.x} ~${randomCoords.y} ~${randomCoords.z}`);

    } else if (hurtEntity?.typeId === "target_dummy:target_dummy_entity" && Number.isInteger(damage)) {

        let damageValue = damage;
        hurtEntity.triggerEvent("on_hurt");

        hurtEntity.runCommand(`summon target_dummy:damage_value "${damageValue}.0" ~${randomCoords.x} ~${randomCoords.y} ~${randomCoords.z}`);
    }
});